<template>
  <div class="page-box" style="position: relative;">
    <table-box
      ref="formCountryCodeTable"
      class="page-table"
      :data="formCountryCodeTableWidgetDataList"
      :size="layoutStore.defaultFormItemSize"
      :row-config="{isCurrent: false, isHover: true}"
      :seq-config="{startIndex: ((formCountryCodeTableWidgetCurrentPage - 1) * formCountryCodeTableWidgetPageSize)}"
      :sort-config="{remote: true}"
      :hasExtend="true"
      @sort-change="formCountryCodeTableWidget.onSortChange"
      @refresh="formCountryCodeTableWidget.refreshTable()"
    >
      <template #operator>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onAddCountryCodeClick()"
          >
          新建
        </el-button>
        <el-button
          type="primary"
          :size="layoutStore.defaultFormItemSize"
          @click="onExportCountryCodeClick()"
          >
          导出
        </el-button>
        <el-upload
          class="btn-import"
          :auto-upload="false"
          action=""
          :show-file-list="false"
          accept=".xls,.xlsx"
          style="display: inline-block;"
          :on-change="onImportCountryCodeClick"
        >
          <template #trigger>
            <el-button
              type="primary"
              :size="layoutStore.defaultFormItemSize"
            >
              导入
            </el-button>
          </template>
        </el-upload>
      </template>
      <vxe-column title="序号" type="seq" :index="formCountryCodeTableWidget.getTableIndex" :width="80" />
      <vxe-column title="英文名称" field="englishName" />
      <vxe-column title="国家/地区" field="country" />
      <vxe-column title="国家代码" field="countryCode" />
      <vxe-column title="区号" field="areaCode" />
      <vxe-column title="拼音" field="pinYin" />
      <vxe-column title="拼音首字母" field="firstCode" />
      <vxe-column title="操作" fixed="right">
        <template v-slot="scope">
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onEditCountryCodeClick(scope.row)"
          >
            编辑
          </el-button>
          <el-button
            link
            type="primary"
            :size="layoutStore.defaultFormItemSize"
            @click.stop="onDeleteCountryCodeClick(scope.row)"
          >
            删除
          </el-button>
        </template>
      </vxe-column>
      <template slot="empty">
        <div class="table-empty unified-font">
          <img src="@/assets/img/empty.png">
          <span>暂无数据</span>
        </div>
      </template>
      <!-- 分页 -->
      <template #pagination>
        <el-row type="flex" justify="end" style="margin-top: 10px;">
          <el-pagination
            :total="formCountryCodeTableWidgetTotalCount"
            :current-page="formCountryCodeTableWidgetCurrentPage"
            :page-size="formCountryCodeTableWidgetPageSize"
            :page-sizes="[10, 20, 50, 100]"
            layout="total, prev, pager, next, sizes"
            @current-change="formCountryCodeTableWidget.onCurrentPageChange"
            @size-change="formCountryCodeTableWidget.onPageSizeChange">
          </el-pagination>
        </el-row>
      </template>
    </table-box>
    <label v-if="subPage" class="page-close-box" @click="onCancel()">
      <img src="@/assets/img/back2.png" alt="">
    </label>
  </div>
</template>

<script lang="ts">
export default {
  name: 'formCountryCode',
};
</script>

<script setup lang="ts">
import { VxeColumn, VxeTable } from 'vxe-table';
import { ANY_OBJECT } from '@/types/generic';
import { DictData, DictionaryBase } from '@/common/staticDict/types';
import { ElMessage, ElMessageBox, UploadFile } from 'element-plus';
import { useRoute, useRouter } from 'vue-router';
import { useCommon } from '@/common/hooks/useCommon';
import { useLayoutStore, useStaticDictStore } from '@/store';
import { useDownload } from '@/common/hooks/useDownload';
import { useDropdown } from '@/common/hooks/useDropdown';
import { DropdownOptions, ListData } from '@/common/types/list';
import { useTable } from '@/common/hooks/useTable';
import { TableOptions } from '@/common/types/pagination';
import { useUpload } from '@/common/hooks/useUpload';
import { useUploadWidget } from '@/common/hooks/useUploadWidget';
import { DictionaryController } from '@/api/system';
import { treeDataTranslate, findItemFromList, findTreeNodePath, findTreeNode, stringCase } from '@/common/utils';
import { CountryCodeData } from '@/api/generated/countryCodeController';
import { CountryCodeController } from '@/api/generated';
import FormEditCountryCode from '@/pages/tourVisa/formEditCountryCode.vue';

const router = useRouter();
const route = useRoute();
const layoutStore = useLayoutStore();
const { downloadFile } = useDownload();
const { getUploadHeaders, getUploadActionUrl, fileListToJson, parseUploadData, getPictureList } = useUpload();
const {
  Delete,
  Search,
  Edit,
  Plus,
  Refresh,
  Picture,
  Dialog,
  mainContextHeight,
  clientHeight,
  checkPermCodeExist,
  parseParams,
  parseArrayParams,
  formatDateByStatsType,
  getDateRangeFilter,
} = useCommon();
// 静态字典
const { staticDict: StaticDict } = useStaticDictStore();

const props = withDefaults(
  defineProps<{
    subPage?: number | string | boolean;
  }>(),
  {
    subPage: 0,
  },
);


const onCancel = () => {
  layoutStore.removeCachePage(route.name as string);
  route.meta.refreshParentCachedPage = true;
  router.go(-1);
};

const onResume = () => {
  refreshFormCountryCode();
};

/**
 * 表格组件数据获取函数，返回Promise
 */
const loadFormCountryCodeTableWidgetData = (params: ANY_OBJECT) => {
  if (params == null) params = {};
  params = {
    ...params,
  };
  return new Promise((resolve, reject) => {
    CountryCodeController.list(params).then(res => {
      resolve({
        dataList: res.data.dataList,
        totalCount: res.data.totalCount
      });
    }).catch(e => {
      reject(e);
    });
  });
};
/**
 * 表格组件数据获取检测函数，返回true正常获取数据，返回false停止获取数据
 */
const loadFormCountryCodeTableVerify = () => {
  return true;
};
/**
 * 新建
 */
const onAddCountryCodeClick = (row?: CountryCodeData) => {
  let params: ANY_OBJECT = {
  };

  Dialog
    .show('新建', FormEditCountryCode, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formCountryCodeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 编辑
 */
const onEditCountryCodeClick = (row?: CountryCodeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  Dialog
    .show('编辑', FormEditCountryCode, { area: '900px' }, { ...params, subPage: true })
    .then(res => {
      formCountryCodeTableWidget.refreshTable();
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
};
/**
 * 导出
 */
const onExportCountryCodeClick = (row?: CountryCodeData) => {
  let params: ANY_OBJECT = {
  };

  CountryCodeController.export(params, '表格组件.xlsx').then(res => {
    ElMessage.success('导出成功');
  }).catch(e => {
    ElMessage.error(e.errorMessage);
  });
};
/**
 * 导入
 */
const onImportCountryCodeClick = (file) => {
  let params: ANY_OBJECT = {
    importFile: file.raw,
    // 是否忽略表头
    skipHeader: false
  };

  CountryCodeController.import(params).then(res => {
    ElMessage.success('导入成功');
    formCountryCodeTableWidget.refreshTable();
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
/**
 * 删除
 */
const onDeleteCountryCodeClick = (row?: CountryCodeData) => {
  let params: ANY_OBJECT = {
    id: row?.id,
  };

  ElMessageBox.confirm('是否删除此记录？').then(res => {
    CountryCodeController.delete(params).then(res => {
      ElMessage.success('删除成功');
      formCountryCodeTableWidget.refreshTable(false, 1);
    }).catch(e => {
      // TODO: 异常处理
      console.error(e);
    });
  }).catch(e => {
    // TODO: 异常处理
    console.error(e);
  });
};
// 表格组件表格组件参数
const formCountryCodeTableOptions: TableOptions<CountryCodeData> = {
  loadTableData: loadFormCountryCodeTableWidgetData,
  verifyTableParameter: loadFormCountryCodeTableVerify,
  paged: true,
  rowSelection: false,
  orderFieldName: undefined,
  ascending: true,
};
// 表格组件表格组件
const formCountryCodeTable = ref();
const formCountryCodeTableWidget = useTable(formCountryCodeTableOptions);
const {
  dataList: formCountryCodeTableWidgetDataList,
  currentPage: formCountryCodeTableWidgetCurrentPage,
  pageSize: formCountryCodeTableWidgetPageSize,
  totalCount: formCountryCodeTableWidgetTotalCount,
} = formCountryCodeTableWidget;
const refreshFormCountryCode = () => {
  // 刷新段落
  formCountryCodeTableWidget.refreshTable();
};
/**
 * 重置过滤值
 */
const resetFormCountryCode = () => {
  refreshFormCountryCode();
};
/**
 * 重置所有过滤值
 */
const resetFilter = () => {
  resetFormCountryCode();
};
const formInit = () => {
  refreshFormCountryCode();
};

onMounted(() => {
  formInit();
});
</script>
